/****************************************************************************/
/*  Text to MZTϊc[                                                   */
/*--------------------------------------------------------------------------*/
/* `C`iŐV΂ɏׂjVersion (J).(ver)() */
/* H____ NH________ CT R_________________________________ */
/* 2021-01-02 Takky          Update   Version 1.3 G[̃_CAOC  */
/* 2020-03-10 Takky          Update   Version 1.2 t@CJiΉ(K/C)   */
/* 2017-10-17 Takky          Bugfix   Version 1.1 mzft@CAgr[g */
/* 2017-09-19 Takky          Coding   Version 1.0 J                */
/****************************************************************************/

/**  CN[ht@C  **/
#include <windows.h>			//  ͕K{
#include <commdlg.h>			//  t@CQƂŎg
#include <shellapi.h>			//  Drag & Drop
#include <stdio.h>				//  sprintfgĂ邩˥
#include <stdlib.h>				//  CCugpĂ邽߁B
#include <string.h>				//  XgO삪邩
#include <alloc.h>				//  [݂gĂ܂
#include <errno.h>				//  G[pgĂȂ
#include <ctype.h>				//  Kv
#include <dir.h>				//  fnsplit֐p

#include "txt2mzt.h"

#define	TITLE_LINE	"Text to MZTϊc["
#define	MEMORY_SIZE	65536		// 64KB
HANDLE	hInst;
static char cpStateBuffer[MEMORY_SIZE];
static RECT rctEdit1, rctEdit2;
static char mbuf[512];

static int isHex(char *);
static int isAddr(char *);
static void upper(char *, char *);
static void BinaryProc(const char *, const char *, int);
static void TextProc(HWND, const char *, int , int, int, int, int);
static int WriteMZTFile(const char *, char *, char *, char *, char *);
int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
DWORD FAR PASCAL MainProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK _export About(HWND, unsigned, WORD, LONG);
BOOL CALLBACK _export MessageProc(HWND, unsigned, WORD, LONG);

static int isHex(char *buf)
{
	if ((((*buf >='0') && (*buf <='9')) || ((*buf >='A') && (*buf <='F'))) &&
		(((*(buf+1) >='0') && (*(buf+1) <='9')) || ((*(buf+1) >='A') && (*(buf+1) <='F'))))
		return 1;
	else
		return 0;
}

static int isAddr(char *buf)
{
	if ((((*buf >='0') && (*buf <='9')) || ((*buf >='A') && (*buf <='F'))) &&
		(((*(buf+1) >='0') && (*(buf+1) <='9')) || ((*(buf+1) >='A') && (*(buf+1) <='F'))) &&
		(((*(buf+2) >='0') && (*(buf+2) <='9')) || ((*(buf+2) >='A') && (*(buf+2) <='F'))) &&
		(((*(buf+3) >='0') && (*(buf+3) <='9')) || ((*(buf+3) >='A') && (*(buf+3) <='F'))))
		return 1;
	else
		return 0;
}

static void upper(char *dst, char *src)
{
	while (*src) {
		*dst = toupper(*src);
		dst++;
		src++;
	}
}

static void BinaryProc(const char *szFileName, const char *saddr, int bUnixText)
{
long lStartAddr;
long lsAdr, leAdr;
HANDLE hFile;
HGLOBAL hMem2;
DWORD dwSize, dwErr, dwReadSize;
char buf[256], *cpDumpBuffer;
char *dst, *src;

	lStartAddr = strtol(saddr, NULL, 16);
	if ((hFile = CreateFile(szFileName, GENERIC_READ, FILE_SHARE_READ,
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox(NULL, "eLXgt@CI[vł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((dwSize = GetFileSize(hFile, NULL)) == 0xffffffff) {
		dwErr = GetLastError();
		if (dwErr != NO_ERROR) {
			memset(buf, 0x00, sizeof(buf));
			snprintf(buf, sizeof(buf), "eLXgt@C̃TCY擾ŃG[܂(%d)", dwErr);
			MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
			CloseHandle(hFile);
			return;
		}
	}
	if ((lStartAddr + dwSize) >= MEMORY_SIZE) {
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "eLXgt@C傫邩JnAhX傫܂B\n_vt@CTCY:%d",
			dwSize);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((hMem2 = GlobalAlloc(GMEM_FIXED, dwSize)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@Ci[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return;
	}
	if ((cpDumpBuffer = (char *)GlobalLock(hMem2)) == NULL) {
		dwErr = GetLastError();
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "_vt@Ci[擾Ɏs܂(%d)", dwErr);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalFree(hMem2);
		CloseHandle(hFile);
		return;
	}
	ReadFile(hFile, cpDumpBuffer, dwSize, &dwReadSize, NULL);
	if (dwSize != dwReadSize) {
		MessageBox(NULL, "_vt@Cǂݍ߂܂ł", TITLE_LINE, MB_OK | MB_ICONSTOP);
		GlobalUnlock(hMem2);
		GlobalFree(hMem2);
		CloseHandle(hFile);
		return;
	}
	CloseHandle(hFile);

	lsAdr = lStartAddr;
	leAdr = lStartAddr + dwSize - 1;
	if (bUnixText == 0)
		memcpy((cpStateBuffer+lStartAddr), cpDumpBuffer, dwSize);
	else {
		dst = (cpStateBuffer+lStartAddr);
		src = cpDumpBuffer+18; /* UNIXpwb_̍폜 */
		leAdr -= 18;
		while (dwSize > 0) {
			if (*src == 0x0a)
				*dst = 0x0d;   /* LF->CR */
			else
				*dst = *src;
			dst++;
			src++;
			dwSize--;
		}
		*dst = 0x00; /* NULL } */
	}
	GlobalUnlock(hMem2);
	GlobalFree(hMem2);
	memset(buf, 0x00, sizeof(buf));
	snprintf(buf, sizeof(buf), "܂\nAhX:$%04X - $%04X", lsAdr, leAdr);
	MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONINFORMATION);
}

#pragma warn -8004
static void TextProc(HWND hWnd, const char *szFileName, int bSum, int bAddSum, int bLowOnly, int bOhMZsum, int bCRC)
{
FILE *fp;
char rbuf[1024], cbuf[1024], buf[512], *cp, tmp[16];
long iSum, iVSum[16], iASum;
char adr[5], data[17][4];
unsigned char wbuf[16];
int iNum, i, j, isErr, iNum2, iNum3;
long lStartAddr, cdata, lsAdr, leAdr;
int clen;
char mzsum[4], mzvsum[5];
unsigned short crcSum;
unsigned char crcData;

	if ((fp = fopen(szFileName, "r")) == NULL) {
		memset(buf, 0x00, sizeof(buf));
		snprintf(buf, sizeof(buf), "eLXgt@CI[vł܂(%d)", errno);
		MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
		return;
	}
	lsAdr = 65536;
	leAdr = 0;
	iSum = 0;
	iASum = 0;
	isErr = 0;
	crcSum = 0;
	memset((void *)iVSum, 0x00, sizeof(iVSum));
	memset(rbuf, 0x00, sizeof(rbuf));
	memset(cbuf, 0x00, sizeof(cbuf));
	while (fgets(rbuf, sizeof(rbuf), fp) != NULL) {
		if (strlen(rbuf) <=3) continue;
		upper(cbuf, rbuf);
		if (isAddr(cbuf)) {
			cp = strtok(cbuf, " \n");
			strncpy(adr, cp, 5);
			iNum = 0;
			while ((cp = strtok(NULL, " \n")) != NULL) {
				if ((clen = strlen(cp)) <= 2)
					strncpy(data[iNum], cp , 3);
				else {
					if (bOhMZsum == 1) {
						memset(mzsum, 0x00, sizeof(mzsum));
						data[iNum][0] = *(cp+1);
						strncpy(&data[iNum][1], (cp+3) , 2);
					} else {
						strncpy(data[iNum], (cp+clen-2) , 3);
					}
				}
				if (bCRC == 1) {
					/* Oh!XCRC^Cv̏ꍇA:̎ɃXy[X̂Ŗ */
					if (data[iNum][0] == ':')
						;
					else
						iNum++;
				} else
					iNum++;
				if (iNum > 16) break;
			}
			lStartAddr = strtol(adr, NULL, 16);
			if (lStartAddr >= 0 || lStartAddr <= 65535) {
				for (i=0; i<(bSum == 1 ? iNum-1 : iNum); i++) {
					if (!isHex(data[i])) {
						fclose(fp);
						memset(mbuf, 0x00, sizeof(mbuf));
						//snprintf(buf, sizeof(buf), "f[^G[\n@OAhX:%s\n@ItZbg:%02X\n@f[^:%s", adr, i, data[i]);
						//MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						snprintf(mbuf, sizeof(mbuf), "f[^G[\r\n@OAhX:%s\r\n@ItZbg:%02X\r\n@f[^:%s\r\n(E00)", adr, i, data[i]);
						DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc);
						return;
					}
					cdata = strtol(data[i], NULL, 16);
					iSum += cdata;
					wbuf[i] = (unsigned char)cdata;
					iVSum[i] += cdata;
					iASum += cdata;
					if (bCRC == 1) {
						crcData = cdata;
						for (j=0; j<8; j++) {
							if ((crcSum & 0x8000) != 0) {
								crcSum = crcSum << 1;
								crcSum = crcSum ^ 0x1021;
							} else {
								crcSum = crcSum << 1;
							}
							if ((crcData & 0x80) != 0) {
								crcData = crcData << 1;
								crcSum = crcSum ^ 0x0001;
							} else {
								crcData = crcData << 1;
							}
						}
					}
				}
				if (bSum == 1) {
					if (bAddSum == 1) {
						if (bLowOnly == 1)
							iSum += (lStartAddr & 0x000000ff);
						else
							iSum += ((lStartAddr & 0x000000ff) + ((lStartAddr >> 8) & 0x000000ff));
					}
					if (bOhMZsum == 1) {
						iSum = iSum & 0x00000fff;
					} else {
						iSum = iSum & 0x000000ff;
					}
			//		if (!isHex(data[iNum-1])) {
			//			fclose(fp);
			//			memset(mbuf, 0x00, sizeof(mbuf));
			//			snprintf(mbuf, sizeof(mbuf), "`FbNTf[^G[\r\n@OAhX:%s\r\n@f[^:%s\r\n(E01)", adr, data[iNum-1]);
			//			DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc);
			//			return;
			//		}
					if (iSum != strtol(data[iNum-1], NULL, 16)) {
						fclose(fp);
						memset(mbuf, 0x00, sizeof(mbuf));
						if (bOhMZsum == 1) {
							//snprintf(buf, sizeof(buf), "`FbNTG[\n@AhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%03X", adr, data[iNum-1], iSum);
							snprintf(mbuf, sizeof(mbuf), "`FbNTG[\r\n@AhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%03X\r\n(E02)", adr, data[iNum-1], iSum);
						} else {
							//snprintf(buf, sizeof(buf), "`FbNTG[\n@AhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%02X", adr, data[iNum-1], iSum);
							snprintf(mbuf, sizeof(mbuf), "`FbNTG[\r\n@AhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%02X\r\n(E03)", adr, data[iNum-1], iSum);
						}
						//MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc);
						return;
					}
				}
				if (lsAdr > lStartAddr) lsAdr = lStartAddr;
				if (leAdr < (lStartAddr+(bSum == 1 ? iNum-2 : iNum-1)))
					leAdr = (lStartAddr+(bSum == 1 ? iNum-2 : iNum-1));
				memcpy((cpStateBuffer+lStartAddr), wbuf, (bSum == 1 ? iNum-1 : iNum));
			}
		/* 20110311 add */
		} else if (bSum == 1 && memcmp(cbuf, "SUM", 3) == 0) {
			cp = strtok(cbuf, " \n");
			memset(mbuf, 0x00, sizeof(mbuf));
			snprintf(mbuf, sizeof(mbuf), "c`FbNTG[\r\n@OAhX:%s\r\n", adr);
			iNum3 = 0;
			while (cp != NULL) {
				cp = strtok(NULL, " \n");
				if (cp != NULL && strlen(cp) == 2)
					iNum3++;
			}
			upper(cbuf, rbuf);
			cp = strtok(cbuf, " \n");
			for (iNum2 = 0; iNum2 < iNum3; iNum2++) {
				cp = strtok(NULL, " \n");
				if (!isHex(cp)) {
					fclose(fp);
					memset(mbuf, 0x00, sizeof(mbuf));
					//snprintf(buf, sizeof(buf), "`FbNTf[^G[\n@OAhX:%s\n@ItZbg:+%02X\n@f[^:%s", adr, iNum2, cp);
					snprintf(mbuf, sizeof(mbuf), "`FbNTf[^G[\r\n@OAhX:%s\r\n@ItZbg:+%02X\r\n@f[^:%s\r\n(E04)", adr, iNum2, cp);
					//MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
					DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc);
					return;
				}
				if ((iVSum[iNum2] & 0x00ff) != strtol(cp, NULL, 16)) {
					strcat(mbuf, "@@+");
					memset(tmp, 0x00, sizeof(tmp));
					tmp[0] = (char)(((iNum2 < 10) ? iNum2+0x30 : iNum2+0x37) & 0x00ff);
					strcat(mbuf, tmp);
					strcat(mbuf, "@");
					strcat(mbuf, cp);
					memset(tmp, 0x00, sizeof(tmp));
					snprintf(tmp, sizeof(tmp), "/%02X\r\n", (iVSum[iNum2] & 0x00ff));
					strcat(mbuf, tmp);
					isErr = 1;
				}
			}
			if (isErr) {
				fclose(fp);
				//MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
				strcat(mbuf, "\r\n(E05)");
				DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc);
				return;
			} else {
				cp = strtok(NULL, " \n");
				memset(tmp, 0x00, sizeof(tmp));
				if (bCRC == 0) {
					if ((clen = strlen(cp)) <= 2) /* 2011-09-28 debug */
						strncpy(tmp, cp , 3);
					else
						strncpy(tmp, (cp+clen-2) , 3); /* 2011-09-28 debug */
					if ((iASum & 0x00ff) != strtol(tmp, NULL, 16)) {
						fclose(fp);
						memset(mbuf, 0x00, sizeof(mbuf));
						//snprintf(buf, sizeof(buf), "c`FbNTG[\n@OAhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%02X", adr, tmp, (iASum & 0x00ff));
						snprintf(mbuf, sizeof(mbuf), "c`FbNTG[\r\n@OAhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%02X\r\n(E06)", adr, tmp, (iASum & 0x00ff));
						//MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc);
						return;
					}
				} else {
					strncpy(tmp, cp , 4);
					if (crcSum != strtol(tmp, NULL, 16)) {
						fclose(fp);
						memset(mbuf, 0x00, sizeof(mbuf));
						//snprintf(buf, sizeof(buf), "bqbG[\n@OAhX:%s\n@wbqb:%s\n@Zobqb:%04X", adr, tmp, crcSum);
						snprintf(mbuf, sizeof(mbuf), "bqbG[\r\n@OAhX:%s\r\n@wbqb:%s\r\n@Zobqb:%04X\r\n(E07)", adr, tmp, crcSum);
						//MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
						DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc);
						return;
					}
				}
			}
			isErr = 0;
			iASum = 0;
			crcSum = 0;
			memset((void *)iVSum, 0x00, sizeof(iVSum)); /* 20110312 */
		} else if (bOhMZsum == 1 && memcmp(cbuf, "------------------------------", 30) == 0) {
			memset(mzvsum, 0x00, sizeof(mzvsum));
			memcpy(mzvsum, &cbuf[strlen(cbuf)-5], 4);
			if ((iASum & 0xffff) != strtol(mzvsum, NULL, 16)) {
				fclose(fp);
				memset(mbuf, 0x00, sizeof(mbuf));
				//snprintf(buf, sizeof(buf), "c`FbNTG[\n@OAhX:%s\n@w`FbNT:%s\n@Zo`FbNT:%04X", adr, mzvsum, (iASum & 0xffff));
				snprintf(mbuf, sizeof(mbuf), "c`FbNTG[\r\n@OAhX:%s\r\n@w`FbNT:%s\r\n@Zo`FbNT:%04X\r\n(E08)", adr, mzvsum, (iASum & 0xffff));
				//MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONSTOP);
				DialogBox(hInst, "ResultBox", hWnd, (DLGPROC)MessageProc);
				return;
			}
			isErr = 0;
			iASum = 0;
			memset((void *)iVSum, 0x00, sizeof(iVSum)); /* 20110312 */
		}
		iSum = 0;
		memset(rbuf, 0x00, sizeof(rbuf));
		memset(cbuf, 0x00, sizeof(cbuf));
	}
	fclose(fp);
	memset(buf, 0x00, sizeof(buf));
	snprintf(buf, sizeof(buf), "܂\nAhX:$%04X - $%04X", lsAdr, leAdr);
	MessageBox(NULL, buf, TITLE_LINE, MB_OK | MB_ICONINFORMATION);
}
#pragma warn .8004

static int WriteMZTFile(const char *FileName, char *MZTFName, char *staddr, char *edaddr, char *exaddr)
{
HANDLE hFile;
DWORD dwWriteBytes;
char szNewFile[MAX_PATH], HEAD[128];
long lStart, lEnd, lExec, lSize;
DWORD dwLen;

	strncpy(szNewFile, FileName, MAX_PATH);
	strcat(szNewFile, ".old");
	MoveFile(FileName, szNewFile);
	if ((hFile = CreateFile(FileName, GENERIC_WRITE, 0, NULL,
		OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
		MessageBox( NULL, "MZTt@CI[vł܂BgpAANZXȂǂ̊mFĂB",
			TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return -1;
	}
/* MZTwb_
  00h     Attribute
	01h-11h Filename(0x0d end), 20padding
  12h,13h Filesize (Intel)
  14h,15h Store Address
  16h,17h Jump Address
   - 128bytes, null padding.
*/
	memset(HEAD, 0x00, sizeof(HEAD));
	HEAD[0] = 0x01;	/* 2017-10-17 add */
	memset(&HEAD[1], 0x20, 17);
	memcpy(&HEAD[1], MZTFName, strlen(MZTFName));
	HEAD[1+strlen(MZTFName)] = 0x0d;	/* 2020-03-10 add */
	lStart = strtol(staddr, NULL, 16);
	lEnd = strtol(edaddr, NULL, 16);
	lExec = strtol(exaddr, NULL, 16);
	lSize = lEnd - lStart + 1;
	dwWriteBytes = (DWORD)lSize;
	memcpy(&HEAD[0x12], &dwWriteBytes, sizeof(DWORD));
	dwWriteBytes = (DWORD)lStart;
	memcpy(&HEAD[0x14], &dwWriteBytes, sizeof(DWORD));
	dwWriteBytes = (DWORD)lExec;
	memcpy(&HEAD[0x16], &dwWriteBytes, sizeof(DWORD));
	dwWriteBytes = 128;
	WriteFile(hFile, HEAD, dwWriteBytes, &dwWriteBytes, NULL);
	if ((long)dwWriteBytes != 128) {
		MessageBox(NULL, "MZTt@C̃wb_e𐳏ɏ߂܂łB", TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return -1;
	}
	WriteFile(hFile, &cpStateBuffer[lStart], lSize, &dwWriteBytes, NULL);
	if ((long)dwWriteBytes != lSize) {
		MessageBox(NULL, "MZTt@C̖{̓e𐳏ɏ߂܂łB", TITLE_LINE, MB_OK | MB_ICONSTOP);
		CloseHandle(hFile);
		return -1;
	}
	CloseHandle(hFile);
	return 0;
}

/** CCallback֐ **/
#pragma warn -par
DWORD FAR PASCAL MainProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
static char szSaveFileName[MAX_PATH];
static char szDumpFileName[MAX_PATH];
static char szDropFileName[MAX_PATH];
static int	bType = 0;
static int	bSum = 1;
static int	bAddSum = 0;
static int	bLowOnly = 0;
static int	bOhMZsum = 0;
static int	bUnixText = 0;
static int	bKanaConv = 1;	// 2020-03-10 add
static char szStartAddr[5];
static char szMZTFileName[17];
static char szMZTStartAddr[5];
static char szMZTEndAddr[5];
static char szMZTExecAddr[5];
static int	bCRC = 0;
OPENFILENAME	OFN;
char	Filter[256], szCurDir[MAX_PATH], buf[512];
int	sPos, tmp;
POINT ptDrop;
DWORD err;

	switch (message) {
/** _CAȌ **/
		case WM_INITDIALOG:
			GetWindowRect(GetDlgItem(hWnd, IDC_EDIT1), &rctEdit1);
			GetWindowRect(GetDlgItem(hWnd, IDC_EDIT2), &rctEdit2);
			DragAcceptFiles(hWnd, TRUE);
			memset(szSaveFileName, 0x00, sizeof(szSaveFileName));
			memset(szDumpFileName, 0x00, sizeof(szDumpFileName));
			if (bType == 0)
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON1);
			else
				CheckRadioButton(hWnd, IDC_RADIOBUTTON1, IDC_RADIOBUTTON2,
					IDC_RADIOBUTTON2);
			if (bSum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX1, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX1, TRUE);
			if (bAddSum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX2, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX2, TRUE);
			if (bLowOnly == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX3, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX3, TRUE);
			if (bOhMZsum == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX5, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX5, TRUE);
			if (bCRC == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX7, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX7, TRUE);
			/* 2020-03-10 add */
			if (bKanaConv == 0)
				CheckDlgButton(hWnd, IDC_CHECKBOX4, FALSE);
			else
				CheckDlgButton(hWnd, IDC_CHECKBOX4, TRUE);
			/* 2020-03-10 add-end */
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX1), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX2), TRUE);
			if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
				EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), TRUE);
			else
				EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX5), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX7), TRUE);
			EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), FALSE);
			EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX6), FALSE);
			memset(cpStateBuffer, 0x00, sizeof(cpStateBuffer));
			break;

/** t@C̃hbv **/
		case WM_DROPFILES:
			/* hbvꂽt@C1ڂ̗pă_CAO֏o */
			DragQueryPoint((HDROP)wParam, &ptDrop);
			DragQueryFile((HDROP)wParam, 0, szDropFileName, MAX_PATH);
			DragFinish((HDROP)wParam);
			ptDrop.y += GetSystemMetrics(SM_CYCAPTION);
			/* txtf[^̃hbv͈̓`FbNBQƃ{^̈ʒuGfBbg{bNX܂ */
			if ((ptDrop.x >= rctEdit1.left && ptDrop.x <= rctEdit1.right) &&
				(ptDrop.y >= rctEdit1.top && ptDrop.y <= rctEdit1.bottom)) {
				SetDlgItemText(hWnd, IDC_EDIT1, szDropFileName);
				strcpy(szSaveFileName, szDropFileName);
				InvalidateRect(hWnd, NULL, TRUE);
			}
			/* _vt@C̃hbv͈̓`FbNBQƃ{^̈ʒuGfBbg{bNX܂ */
			if ((ptDrop.x >= rctEdit2.left && ptDrop.x <= rctEdit2.right) &&
				(ptDrop.y >= rctEdit2.top && ptDrop.y <= rctEdit2.bottom)) {
				SetDlgItemText(hWnd, IDC_EDIT2, szDropFileName);
				strcpy(szDumpFileName, szDropFileName);
				InvalidateRect(hWnd, NULL, TRUE);
			}
			break;

		// {^ñR}h
		case WM_COMMAND:
			switch(wParam) {
				case IDC_RADIOBUTTON1:
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX1), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX2), TRUE);
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), TRUE);
					else
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX5), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX7), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX6), FALSE);
					break;

				case IDC_RADIOBUTTON2:
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX1), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX2), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX5), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX7), FALSE);
					EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), TRUE);
					EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX6), TRUE);
					break;

				case IDC_CHECKBOX2:
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), TRUE);
					else
						EnableWindow(GetDlgItem(hWnd, IDC_CHECKBOX3), FALSE);
					break;

				case IDC_BUTTON1:	// txtQ
					/* J_CAOoăt@CIĂ炤 */
					memset(szCurDir, 0x00, sizeof(szCurDir));
					memset(&OFN, 0x00, sizeof(OFN));
					memset(Filter, 0x00, sizeof(Filter));
					strcpy(Filter, "eLXgf[^ (*.*)");
					sPos = strlen(Filter);
					strcpy(&Filter[sPos+1], "*.*");
					OFN.lStructSize = sizeof(OPENFILENAME);
					OFN.hwndOwner = hWnd;
					OFN.hInstance = hInst;
					OFN.lpstrFilter = Filter;
					OFN.lpstrCustomFilter = NULL;
					OFN.nMaxCustFilter = 0;
					OFN.nFilterIndex = 0;
					OFN.lpstrFile = szCurDir;
					OFN.nMaxFile = sizeof(szCurDir);
					OFN.lpstrInitialDir = NULL;
					OFN.lpstrFileTitle = NULL;
					OFN.nMaxFileTitle = 0;
					OFN.lpstrTitle = "eLXgf[^t@C̑I";
					OFN.nFileOffset = 0;
					OFN.nFileExtension = 0;
					OFN.lpstrDefExt = NULL;
					OFN.lCustData = NULL;
					OFN.lpfnHook = NULL;
					OFN.lpTemplateName = NULL;
					OFN.Flags = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
					if (GetOpenFileName(&OFN)) {
						SetDlgItemText(hWnd, IDC_EDIT1, OFN.lpstrFile);
						strcpy(szSaveFileName, OFN.lpstrFile);
						InvalidateRect(hWnd, NULL, TRUE);
					}
					/* _CAOLZꂽ牽Ȃ */
					break;

				case IDC_BUTTON2:	// mztt@CQ
					/* J_CAOoăt@CIĂ */
					memset(szCurDir, 0x00, sizeof(szCurDir));
					memset(&OFN, 0x00, sizeof(OFN));
					memset(Filter, 0x00, sizeof(Filter));
					strcpy(Filter, "MZTt@C (*.mzt)");
					sPos = strlen(Filter);
					strcpy(&Filter[sPos+1], "*.mzt");
					OFN.lStructSize = sizeof(OPENFILENAME);
					OFN.hwndOwner = hWnd;
					OFN.hInstance = hInst;
					OFN.lpstrFilter = Filter;
					OFN.lpstrCustomFilter = NULL;
					OFN.nMaxCustFilter = 0;
					OFN.nFilterIndex = 0;
					OFN.lpstrFile = szCurDir;
					OFN.lpstrInitialDir = NULL;
					OFN.nMaxFile = sizeof(szCurDir);
					OFN.lpstrFileTitle = NULL;
					OFN.nMaxFileTitle = 0;
					OFN.lpstrTitle = "MZTt@C̑I";
					OFN.nFileOffset = 0;
					OFN.nFileExtension = 0;
					OFN.lpstrDefExt = NULL;
					OFN.lCustData = NULL;
					OFN.lpfnHook = NULL;
					OFN.lpTemplateName = NULL;
					OFN.Flags = OFN_EXPLORER | OFN_HIDEREADONLY;
					if (GetOpenFileName(&OFN)) {
						SetDlgItemText(hWnd, IDC_EDIT2, OFN.lpstrFile);
						strcpy(szDumpFileName, OFN.lpstrFile);
						InvalidateRect(hWnd, NULL, TRUE);
					}
					/* _CAOLZꂽ牽Ȃ */
					break;

				case IDC_BUTTON3:	// _v`FbN
					//t@CĎ擾
					memset(szSaveFileName, 0x00, sizeof(szSaveFileName));
					GetDlgItemText(hWnd, IDC_EDIT1, szSaveFileName, sizeof(szSaveFileName));
					memset(szDumpFileName, 0x00, sizeof(szDumpFileName));
					GetDlgItemText(hWnd, IDC_EDIT2, szDumpFileName, sizeof(szDumpFileName));
					if (strlen(szSaveFileName) == 0) {
						MessageBox(NULL, "eLXgf[^w肵ĂB", TITLE_LINE, MB_OK | MB_ICONSTOP);
						break;
					}
					// _vڍ׏擾
					if (IsDlgButtonChecked(hWnd, IDC_RADIOBUTTON1))
						bType = 0;
					else
						bType = 1;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX1))
						bSum = 1;
					else
						bSum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX6))
						bUnixText = 1;
					else
						bUnixText = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						bAddSum = 1;
					else
						bAddSum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX5))
						bOhMZsum = 1;
					else
						bOhMZsum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX3))
						bLowOnly = 1;
					else
						bLowOnly = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX7))
						bCRC = 1;
					else
						bCRC = 0;
					memset(szStartAddr, 0x00, sizeof(szStartAddr));
					GetDlgItemText(hWnd, IDC_EDIT3, szStartAddr, 5);
					if (bType == 1) {
						BinaryProc(szSaveFileName, szStartAddr, bUnixText);
					} else {
						TextProc(hWnd, szSaveFileName, bSum, bAddSum, bLowOnly, bOhMZsum, bCRC);
					}
					break;

				case IDC_BUTTON4:	//ϊ
					// _v`FbNƕϊ
					memset(szSaveFileName, 0x00, sizeof(szSaveFileName));
					GetDlgItemText(hWnd, IDC_EDIT1, szSaveFileName, sizeof(szSaveFileName));
					memset(szDumpFileName, 0x00, sizeof(szDumpFileName));
					GetDlgItemText(hWnd, IDC_EDIT2, szDumpFileName, sizeof(szDumpFileName));
					if (strlen(szSaveFileName) == 0) {
						MessageBox(NULL, "eLXgf[^w肵ĂB", TITLE_LINE, MB_OK | MB_ICONSTOP);
						break;
					}
					if (strlen(szDumpFileName) == 0) {
						MessageBox(NULL, "MZTt@Cw肵ĂB", TITLE_LINE, MB_OK | MB_ICONSTOP);
						break;
					}
					// _vڍ׏擾
					if (IsDlgButtonChecked(hWnd, IDC_RADIOBUTTON1))
						bType = 0;
					else
						bType = 1;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX1))
						bSum = 1;
					else
						bSum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX6))
						bUnixText = 1;
					else
						bUnixText = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX2))
						bAddSum = 1;
					else
						bAddSum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX5))
						bOhMZsum = 1;
					else
						bOhMZsum = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX3))
						bLowOnly = 1;
					else
						bLowOnly = 0;
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX7))
						bCRC = 1;
					else
						bCRC = 0;
					/* 2020-03-10 add */
					if (IsDlgButtonChecked(hWnd, IDC_CHECKBOX4))
						bKanaConv = 1;
					else
						bKanaConv = 0;
					/* 2020-03-10 add-end */
					memset(szStartAddr, 0x00, sizeof(szStartAddr));
					GetDlgItemText(hWnd, IDC_EDIT3, szStartAddr, 5);
					if (bType == 1) {
						BinaryProc(szSaveFileName, szStartAddr, bUnixText);
					} else {
						TextProc(hWnd, szSaveFileName, bSum, bAddSum, bLowOnly, bOhMZsum, bCRC);
					}
					memset(szMZTFileName, 0x00, sizeof(szMZTFileName));
					GetDlgItemText(hWnd, IDC_EDIT4, szMZTFileName, 17);
					/* 2020-03-10 add */
					if (bKanaConv == 1) {
						int i ,e;
						union {
							char	c4[4];
							long	l1;
						} u0;
						e = strlen(szMZTFileName);
						for (i=0; i<e; i++) {
							u0.l1 = 0;
							u0.c4[0] = szMZTFileName[i];
							if (u0.l1 >= 161)
							szMZTFileName[i] = (char)((u0.l1 - 32) & 0x000000FF);
						}
					}
					/* 2020-03-10 add-end */
					memset(szMZTStartAddr, 0x00, sizeof(szMZTStartAddr));
					GetDlgItemText(hWnd, IDC_EDIT5, szMZTStartAddr, 5);
					memset(szMZTEndAddr, 0x00, sizeof(szMZTEndAddr));
					GetDlgItemText(hWnd, IDC_EDIT6, szMZTEndAddr, 5);
					memset(szMZTExecAddr, 0x00, sizeof(szMZTExecAddr));
					GetDlgItemText(hWnd, IDC_EDIT7, szMZTExecAddr, 5);
					if (!WriteMZTFile(szDumpFileName, szMZTFileName, szMZTStartAddr, szMZTEndAddr, szMZTExecAddr))
						MessageBox(NULL, "ϊ", TITLE_LINE, MB_OK);
					break;

				case IDC_BUTTON5:		// About...{^
					/* About̃_CAOo */
					DialogBox(hInst, "AboutBox", hWnd, (DLGPROC)About);
					break;

				case IDCANCEL:	// I{^
					DestroyWindow(hWnd);
					PostQuitMessage(0);
					break;

			}
			break;
	}
	return (FALSE);
}
#pragma warn .par

#pragma warn -par
/** AboutBox_CAO{ OK{^ꂽIBȊO͉Ȃ **/
BOOL CALLBACK _export About(HWND hDlg, unsigned message, WORD wParam,
		LONG lParam)
{

	switch (message) {

		/** ڑĨbZ[W **/
		case WM_COMMAND:
			if (wParam == IDOK) {
				EndDialog(hDlg, TRUE);
				return (FALSE);
			}
			break;

		default:
			return(FALSE);
    }
	return (TRUE);
}
BOOL CALLBACK _export MessageProc(HWND hDlg, unsigned message, WORD wParam,
		LONG lParam)
{

	switch (message) {
		case WM_INITDIALOG:
			SetDlgItemText(hDlg, IDC_EDIT8, mbuf);
			break;

		/** ڑĨbZ[W **/
		case WM_COMMAND:
			if (wParam == IDOK) {
				EndDialog(hDlg, TRUE);
				return (FALSE);
			}
			break;

		default:
			return(FALSE);
    }
	return (TRUE);
}
#pragma warn .par

/**  WindowsCGg...NƂsB C_CAOoďIB**/
#pragma warn -par
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{
	hInst = hInstance;
	return (DialogBox(hInst, "MainDialog", NULL, (DLGPROC)MainProc));
}
#pragma warn .par
/** ========================= End of Source ============================== **/
